#! /usr/bin/env python

import os
from parsley import makeGrammar


# cache
_grammar = None


def load_grammar():
    global _grammar
    parser_dir = os.path.dirname(__file__)
    with open(os.path.join(parser_dir, 'grammar.ebnf'), 'rt') as grammar_file:
        grammar_text = grammar_file.read()
    _grammar = makeGrammar(grammar_text, {}, 'Tags')


def parse(input):
    if _grammar is None:
        load_grammar()
    return _grammar(input).expression()


if __name__ == '__main__':
    print parse('test')
    print parse('!test')
    print parse('not test')
    print parse('foo or bar')
    print parse('foo && bar')
    print parse('(test)')
    print parse('(foo || bar)')
    print parse('(foo and !bar)')
